/* $Id: vline.c,v 1.1 2001/10/07 23:14:13 skids Exp $
******************************************************************************

   Graphics library for GGI. Horizontal lines with 8-bit Z.

   Copyright (C) 2001 Brian S. Julin [bri@tull.umassp.edu]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#include "stubs-z8-lib.h"


#define MAX_STACK 2048

#define GETZ \
zbuf->storage_ops->storage2mem(priv->zbuf->storage, y, x + skipping, 0, \
			       &z, 1, 1, bufw)
#define DO_OP \
priv->old_opdraw->drawvline_nc(vis, y, x, skipping + bufidx - idx)

#define UPDATEZ \
zbuf->storage_ops->const2storage(priv->zbuf->storage, y, x, 0, defz, \
				 1, skipping + bufidx - idx)


int GGI_stubs_z8_drawvline(ggi_visual *vis, int x, int y, int h)
{
	Z8_COMMON_DECLS;	
	int idx, bufidx, bufw, skipping;
	u_int8_t z[MAX_STACK];
	int w;

	Z_COMMON_INIT;

	LIBGGICLIP_XYH(vis, x, y, h);

	w = y; y = x; x = w; w = h;

	skipping = 0;

	do {
	  int rc;
	  bufw = w;
	  if (bufw > MAX_STACK) bufw = MAX_STACK;
	  w -= bufw;
	  rc = GETZ;
	  if (0 && (rc > 0) && (rc & GGI_ACCESSFUNC_UNNEEDED)) goto direct;
	} while (0);

	/* This enters one of the RUN_SPANS below, based on zflags */
	Z_COMMON_ENTRY_SWITCH;

	/* If we get here no Z rule has been selected */
	priv->old_opdraw->drawvline_nc(vis, y, x, w + bufw);
	zbuf->storage_ops->const2storage(priv->zbuf->storage, y, x, 0, defz,
					 1, w);
	return 0;
	
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   ==, entry_eq, skip_eq, netloop_eq);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   !=, entry_ne, skip_ne, netloop_ne);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   <, entry_lt, skip_lt, netloop_lt);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   >, entry_gt, skip_gt, netloop_gt);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   <=, entry_lte, skip_lte, netloop_lte);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   >=, entry_gte, skip_gte, netloop_gte);


	return 0;

 direct:
	
	return 0;
}


int GGI_stubs_z8_drawvline_nc(ggi_visual *vis, int x, int y, int h)
{
	Z8_COMMON_DECLS;	
	int idx, bufidx, bufw, skipping;
	u_int8_t z[MAX_STACK];
	int w = h;

	Z_COMMON_INIT;

	w = y; y = x; x = w; w = h;

	skipping = 0;

	do {
	  int rc;
	  bufw = w;
	  if (bufw > MAX_STACK) bufw = MAX_STACK;
	  w -= bufw;
	  rc = GETZ;
	  if (0 && (rc > 0) && (rc & GGI_ACCESSFUNC_UNNEEDED)) goto direct;
	} while (0);

	/* This enters one of the RUN_SPANS below, based on zflags */
	Z_COMMON_ENTRY_SWITCH;

	/* If we get here no Z rule has been selected */
	priv->old_opdraw->drawvline_nc(vis, y, x, w + bufw);
	zbuf->storage_ops->const2storage(priv->zbuf->storage, y, x, 0, defz,
					 1, w);
	return 0;
	
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   ==, entry_eq, skip_eq, netloop_eq);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   !=, entry_ne, skip_ne, netloop_ne);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   <, entry_lt, skip_lt, netloop_lt);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   >, entry_gt, skip_gt, netloop_gt);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   <=, entry_lte, skip_lte, netloop_lte);
	return 0;
	Z_COMMON_RUN_SPANS(GETZ, DO_OP, UPDATEZ, 
			   >=, entry_gte, skip_gte, netloop_gte);
	return 0;

 direct:

	return 0;
}

#undef GETZ
#undef DO_OP
#undef UPDATEZ

int GGI_stubs_z8_putvline(ggi_visual *vis, int x, int y, int w, void *buffer)
{
	return 0;
}

